diff -Naur a/drivers/usb/serial/usb_wwan.c b/drivers/usb/serial/usb_wwan.c
--- a/drivers/usb/serial/usb_wwan.c	2020-11-16 11:08:22.338297723 -0800
+++ b/drivers/usb/serial/usb_wwan.c	2020-11-16 11:48:03.557388285 -0800
@@ -501,8 +501,18 @@
 			  usb_sndbulkpipe(serial->dev, endpoint) | dir,
 			  buf, len, callback, ctx);
 
-	if (intfdata->use_zlp && dir == USB_DIR_OUT)
-		urb->transfer_flags |= URB_ZERO_PACKET;
+    // Added by Quectel in order to process zero packets during bulk out transmission
+	if (dir == USB_DIR_OUT) {
+        struct usb_device_descriptor *desc = &serial->dev->descriptor;
+        if (desc->idVendor == cpu_to_le16(0x05C6) && desc->idProduct == cpu_to_le16(0x9090))
+            urb->transfer_flags |= URB_ZERO_PACKET;
+        if (desc->idVendor == cpu_to_le16(0x05C6) && desc->idProduct == cpu_to_le16(0x9003))
+            urb->transfer_flags |= URB_ZERO_PACKET;
+        if (desc->idVendor == cpu_to_le16(0x05C6) && desc->idProduct == cpu_to_le16(0x9215))
+            urb->transfer_flags |= URB_ZERO_PACKET;
+        if (desc->idVendor == cpu_to_le16(0x2C7C))
+            urb->transfer_flags |= URB_ZERO_PACKET;
+    } 
 
 	return urb;
 }
